
-- logging
map (nil, "*", 99, function (req)
  local status = req_get_status (req)
  local path, query, method, version, host = parse_path (req)
  local ip, port = remote_address (req)
  local sz = req_get_file_size (req)
  if (query) then
    path = string.format ("%s?%s", path, query)
  end
  access ("%s - - [%s] \"%s %s %x\" %d %d\n", ip, current_date, method, path, version, status, sz)
end)

-- default map
map (nil, "*", 0, function (req)
  local path, query, method, version, host = parse_path (req)
  local vhost = req_get_vhost (req)

  req_set_cache_key (req, vhost, ":", path, "?", query)

  local dir_path, file_name, ext, path_info, location = set_path (req, path, index_files)
  if (location) then
    return redirect (req, location, 301)
  end
  if (file_name == nil) then
    if (dir_path) then
      return list_dir (req)
    else
      return respond (req, 404)
    end
  end

  if (forbidden_files[ext]) then
    return respond (req, 403)
  end

  if (to_compress[ext] == nil) then
    req_set_disabled (req, "compress")
  end
  if (content_type[ext]) then
    set_content_type (req, content_type[ext])
  end

  if (fpm_socks[ext]) then
    return fastcgi (req, fpm_socks[ext])
  elseif (to_cache[ext]) then
    req_set_cache (req, 604800)
  end

  send_file (req)
  return true
end)

